SystemOrganization addCategory: #'acceptit-Tests-Fixtures'!
SystemOrganization addCategory: #'acceptit-Tests'!
SystemOrganization addCategory: #'acceptit-Core-Model'!
SystemOrganization addCategory: #'acceptit-Compiler'!

Compiler subclass: #ACCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:18'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock

	^ self compile: origCode in: cls notifying: notify ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:47'!
compile: origCode in: cls notifying: notify ifFail: failBlock

	| origCodeStream parseTree translatedCode |
	origCodeStream := origCode asString readStream.
	self from: origCodeStream class: cls context: nil notifying: notify.
	[
		parseTree := self parserClass matchStream: origCodeStream with: #userStory withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #translate.
	] on: OM2Fail do: [
		self notify: '<-- parse error around here -->' at: origCodeStream position.
		^ failBlock value
	].
	^ Compiler new
		compile: translatedCode readStream
		in: cls
		notifying: notify
		ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:24'!
parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock

	^ [
		| parseTree translatedCode code |
		parseTree := self parserClass matchStream: aStream with: #userStory withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #translate.
		Parser new parse: translatedCode readStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock
	] on: OM2Fail do: [aBlock value]! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:31'!
parserClass

	^ ACParser! !

Object subclass: #ACTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACTestResource class methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:11'!
userStory

	^
'A Title
In order to achieve something
As a role
I want to do something.'! !

!ACTestResource class methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:15'!
userStoryDecompiled

	^
'userStoryATitle
	self purpose: ''achieve something''.
	self	 role: ''role''.
	self means: ''do something.''.'! !

Object subclass: #ACUserStoryContainer
	instanceVariableNames: 'purpose role means'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

ACUserStoryContainer subclass: #ACPlayground
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACPlayground methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:21'!
A Title
In order to achieve something
As a role
I want to do something.! !

!ACPlayground methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:21'!
Driving
In order to reach my destination
As a car owner
I want to be able to drive.! !

!ACUserStoryContainer class methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:18'!
compilerClass

	^ self == ACUserStoryContainer
		ifTrue: [super compilerClass]
		ifFalse: [ACCompiler]! !

!ACUserStoryContainer methodsFor: 'accessing' stamp: 'topa 5/19/2010 13:20'!
means

	^means! !

!ACUserStoryContainer methodsFor: 'accessing' stamp: 'topa 5/19/2010 13:20'!
means: anObject

	means := anObject! !

!ACUserStoryContainer methodsFor: 'accessing' stamp: 'topa 5/19/2010 13:20'!
purpose

	^purpose! !

!ACUserStoryContainer methodsFor: 'accessing' stamp: 'topa 5/19/2010 13:20'!
purpose: anObject

	purpose := anObject! !

!ACUserStoryContainer methodsFor: 'accessing' stamp: 'topa 5/19/2010 13:20'!
role

	^role! !

!ACUserStoryContainer methodsFor: 'accessing' stamp: 'topa 5/19/2010 13:20'!
role: anObject

	role := anObject! !

TestCase subclass: #ACCompilerUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:21'!
testUserStoryCompilation

	| acMethod stMethod |

	acMethod := ACCompiler new compile: ACTestResource userStory  in: self class classified: nil notifying: nil ifFail: [].
	stMethod := Compiler new compile: ACTestResource userStoryDecompiled in: self class classified: nil notifying: nil ifFail: [].

	self 
		should: [acMethod selector = stMethod selector];
		should: [acMethod decompileString = stMethod decompileString].! !

TestCase subclass: #ACParserUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:13'!
match: aString with: aRule

	[ACParser matchAll: aString with: aRule]
		on: OM2Fail
		do: [^ false].
	^ true! !

!ACParserUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:24'!
testUserStoryMatch

	self should: [self match: ACTestResource userStory with: #userStory].
		"
		self 
			purpose: 'achieve something';
			role: 'role';
			means: 'do something'.
		"
		! !

!ACParserUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:10'!
testUserStoryMeansMatch

	self should: [self match: 'I want to do something' with: #meansLine].	! !

!ACParserUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:10'!
testUserStoryPurposeMatch

	self should: [  self match: 'In order to achieve something' with: #purposeLine].! !

!ACParserUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:10'!
testUserStoryRoleMatch

	self should: [ self match: 'As a role' with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:22'!
testUserStoryTitleMatch

	self should: [self match: 'A Title' with: #title].	! !

OMeta2 subclass: #ACParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 18:05'!
charNoNewline =

	<char:x ?[x ~= Character cr]>! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/18/2010 17:51'!
lineEnd =

	<char:x ?[x = Character cr]>! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:01'!
meansLine =

	spaces <``I want to''> spaces <charNoNewline+>:body -> [{#means . body}]! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:02'!
purposeLine =

	 spaces <``In order to''> spaces <charNoNewline+>:body -> [{#purpose . body}]! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:02'!
roleLine =

		 spaces <``As a'' ``n''?> spaces <charNoNewline+>:body -> [{#role . body}]! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:02'!
title =

	<charNoNewline+>:body -> [{#title . body}]! !

!ACParser methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:42'!
userStory =
	
	title:t lineEnd
	purposeLine:purpose lineEnd
	roleLine:role lineEnd
	meansLine:means lineEnd? end -> [{#userStory. t. purpose. role. means}]
	! !

OMeta2 subclass: #ACTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:21'!
rule =

	{symbol:s string:body} -> ['	self ', s asMutator,' ''', body,'''.', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:10'!
title =

	{symbol:t string:s} -> ['userStory', s asLegalSelector capitalized, String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:08'!
translate =
	
	{symbol:type title:t rule:purpose rule:role rule:means}
		-> [t, purpose, role, means]! !
